From 300ef4a0f46164a5054a65ec09ceaa564de9be22 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Nov 20 2020 04:28:29 +0000
Subject: [PATCH 1467/2232] Add conditional DerefMut for UniquePtr


---

diff --git a/src/unique_ptr.rs b/src/unique_ptr.rs
index c4d436e..5a095ff 100644
--- a/src/unique_ptr.rs
+++ b/src/unique_ptr.rs
@@ -6,7 +6,7 @@ use core::ffi::c_void;
 use core::fmt::{self, Debug, Display};
 use core::marker::PhantomData;
 use core::mem;
-use core::ops::Deref;
+use core::ops::{Deref, DerefMut};
 use core::pin::Pin;
 use core::ptr;
 
@@ -119,6 +119,18 @@ where
     }
 }
 
+impl<T> DerefMut for UniquePtr<T>
+where
+    T: UniquePtrTarget + Unpin,
+{
+    fn deref_mut(&mut self) -> &mut Self::Target {
+        match self.as_mut() {
+            Some(target) => Pin::into_inner(target),
+            None => panic!("called deref_mut on a null UniquePtr<{}>", T::__NAME),
+        }
+    }
+}
+
 impl<T> Debug for UniquePtr<T>
 where
     T: Debug + UniquePtrTarget,
diff --git a/tests/ui/unique_ptr_as_mut.stderr b/tests/ui/unique_ptr_as_mut.stderr
index 6b43299..a41f716 100644
--- a/tests/ui/unique_ptr_as_mut.stderr
+++ b/tests/ui/unique_ptr_as_mut.stderr
@@ -1,11 +1,3 @@
-error[E0596]: cannot borrow data in a dereference of `UniquePtr<Shared>` as mutable
-  --> $DIR/unique_ptr_as_mut.rs:19:31
-   |
-19 |     let _: &mut ffi::Shared = &mut shared;
-   |                               ^^^^^^^^^^^ cannot borrow as mutable
-   |
-   = help: trait `DerefMut` is required to modify through a dereference, but it is not implemented for `UniquePtr<Shared>`
-
 error[E0596]: cannot borrow data in a dereference of `UniquePtr<ffi::Opaque>` as mutable
   --> $DIR/unique_ptr_as_mut.rs:22:31
    |

